local ArachnaPoison = {}

function ArachnaPoison:GetActivationSound()
	return "atk_poison"
end

function ArachnaPoison:GetActivationAnimation()
	return "poison_acidic_attack"
end

function ArachnaPoison:EnumerateIcon()
	return "img_usableitem_acidic_poison"
end

function ArachnaPoison:MutateActivationValue(val)
	return val + 2
end

function ArachnaPoison:MutateActivationTurns(val)
	return val + 4
end

function ArachnaPoison:MutateActionPowerBase(val)
	return val + 8
end

function ArachnaPoison:EnumerateMagicalEffects(effects)
	local value = self:GetActivationValue()
	local turns = self:GetActivationTurns()
	local applied_turns = (turns * 2) + 1
	table.insert(effects, {
		method = function (item, effect, params)
			params.target.state:AddStatusEffect(item, "DamageOverTime", self:GetBaseTypeName(), applied_turns, "[ITEM_BASE_TYPE_ARACHNAPOISON]", value)
		end,
		when = "OnStrike",
		name = "POISON",
		from = self:GetName(),
		category = "[IE_CATEGORY_ONSTRIKE]",
		category_title = "[POISON_SECTION]",
		category_name  = substitute(translate_text("[IE_ARACHNAPOISON]"), turns, value)
	})
	
	return effects
end

return ArachnaPoison
