local ManticorePoison = {}

function ManticorePoison:GetActivationSound()
	return "atk_poison"
end

function ManticorePoison:GetActivationAnimation()
	return "poison_draining_attack"
end

function ManticorePoison:EnumerateIcon()
	return "img_usableitem_draining_poison"
end

function ManticorePoison:MutateActivationValue(val)
	return val + 5
end

function ManticorePoison:MutateActivationTurns(val)
	return val + 4
end

function ManticorePoison:MutateActionPowerBase(val)
	return val + 15
end

function ManticorePoison:EnumerateMagicalEffects(effects)
	local value = self:GetActivationValue()
	local turns = self:GetActivationTurns()
	local applied_turns = (turns * 2) + 1
	table.insert(effects, {
		method = function (item, effect, params)
			params.target.state:AddStatusEffect(item, "DamageOverTime", self:GetBaseTypeName(), applied_turns, "[ITEM_BASE_TYPE_MANTICOREPOISON]", value)
		end,
		when = "OnStrike",
		name = "POISON",
		from = self:GetName(),
		category = "[IE_CATEGORY_ONSTRIKE]",
		category_title = "[POISON_SECTION]",
		category_name  = substitute(translate_text("[IE_MANTICOREPOISON]"), turns, value)
	})
	
	return effects
end

return ManticorePoison
