local WyvernPoison = {}

function WyvernPoison:GetActivationSound()
	return "atk_poison"
end

function WyvernPoison:GetActivationAnimation()
	return "poison_sapping_attack"
end

function WyvernPoison:EnumerateIcon()
	return "img_usableitem_sapping_poison"
end

function WyvernPoison:MutateActivationValue(val)
	return val + 10
end

function WyvernPoison:MutateActivationTurns(val)
	return val + 4
end

function WyvernPoison:MutateActionPowerBase(val)
	return val + 24
end

function WyvernPoison:EnumerateMagicalEffects(effects)
	local value = self:GetActivationValue()
	local turns = self:GetActivationTurns()
	local applied_turns = (turns * 2) + 1
	table.insert(effects, {
		method = function (item, effect, params)
			params.target.state:AddStatusEffect(item, "DamageOverTime", self:GetBaseTypeName(), applied_turns, "[ITEM_BASE_TYPE_WYVERNPOISON]", value)
		end,
		when = "OnStrike",
		name = "POISON",
		from = self:GetName(),
		category = "[IE_CATEGORY_ONSTRIKE]",
		category_title = "[POISON_SECTION]",
		category_name  = substitute(translate_text("[IE_WYVERNPOISON]"), turns, value)
	})
	
	return effects
end

return WyvernPoison
