local CustomMoltenMetal = {}

function CustomMoltenMetal:GetActivationSound()
	return "atk_moltenmetal"
end

function CustomMoltenMetal:GetActivationAnimation()
	return "moltenmetal_attack"
end

function CustomMoltenMetal:IsCustomItem()
	return true
end

function CustomMoltenMetal:EnumerateIcon()
	return "img_weapon_moltenmetal"
end

function CustomMoltenMetal:MutateActivationValue(val)
	return val + 9999
end

function CustomMoltenMetal:MutateActionPowerBase(val)
	return 99
end

function CustomMoltenMetal:IsUnavoidableToUse()
	return true
end

function CustomMoltenMetal:EnumerateMagicalEffects(effects)
	local value = self:GetActivationValue()
	table.insert(effects, {
		method = function(item, effect, params)
			params.target.state:AddStatusEffect(item, "KnockedDown", self:GetName(), 1, self:GetName())
			params.target.state:DamageHealth(item, value, self:GetName())
		end,
		when = "OnStrike",
		name = "STURDY",
		from = self:GetName(),
		category = "[IE_CATEGORY_ONSTRIKE]",
		category_title = "[IE_CUSTOM_MOLTENMETAL_TITLE]",
		category_name = "[IE_CUSTOM_MOLTENMETAL]",
		category_icon = "img_status_damage",
	})
	
	return effects
end

function CustomMoltenMetal:GetName()
	return translate_text("[ITEM_CUSTOM_MOLTENMETAL]")
end

return CustomMoltenMetal
