local QuestHandlers = {}

QuestHandlers[61] = {		-- The end game quest
	OnComplete = function ()
		local hero = HeroManager:GetActiveHero()
		
		LOGF("End Of Game, checking GATEHACKER achievement (%d,%d)", hero:GetAttribute("knockGameCount"), hero:GetAttribute("pickGameCount"))
		
		local class = hero:GetClassForStats()
		local gender = hero:GetGenderForStats()
		
		local m_ass_count = Stats.GetStat("ASSASSIN", "COMPLETIONS_MALE")
		local m_bar_count = Stats.GetStat("BARBARIAN", "COMPLETIONS_MALE")
		local m_tem_count = Stats.GetStat("INQUISITOR", "COMPLETIONS_MALE")
		local m_sor_count = Stats.GetStat("WARMAGE", "COMPLETIONS_MALE")
		local f_ass_count = Stats.GetStat("ASSASSIN", "COMPLETIONS_FEMALE")
		local f_bar_count = Stats.GetStat("BARBARIAN", "COMPLETIONS_FEMALE")
		local f_tem_count = Stats.GetStat("INQUISITOR", "COMPLETIONS_FEMALE")
		local f_sor_count = Stats.GetStat("WARMAGE", "COMPLETIONS_FEMALE")
		
		local classes_completed = 0
		
		if (m_ass_count + f_ass_count) > 0 then
			classes_completed = classes_completed + 1
		end
		
		if (m_bar_count + f_bar_count) > 0 then
			classes_completed = classes_completed + 1
		end
		
		if (m_tem_count + f_tem_count) > 0 then
			classes_completed = classes_completed + 1
		end
		
		if (m_sor_count + f_sor_count) > 0 then
			classes_completed = classes_completed + 1
		end
		
		
		Stats.AdjustSPStat(class, "BEST_PLAY_TIME", hero:GetAttribute("play_time"))
		Stats.AdjustSPStat(class, "COMPLETIONS_" .. gender, 1) 
		Stats.AdjustSPStat("OVERALL", "CLASSES_COMPLETED", classes_completed)
		
		Stats.PushSinglePlayerStats(function () end)
		
		if classes_completed == 4 then
			Achievements.AwardAchievement(1, "COMPLETIONIST")
		else
			Achievements.IndicateProgress(1, "COMPLETIONIST", classes_completed, 4)
		end
		
		if (m_ass_count > 0) and (f_ass_count > 0) then
			Achievements.AwardAchievement(1, "EQUALOPPORTUNITY")
		end
		
		if (m_bar_count > 0) and (f_bar_count > 0) then
			Achievements.AwardAchievement(1, "EQUALOPPORTUNITY")
		end
		
		if (m_tem_count > 0) and (f_tem_count > 0) then
			Achievements.AwardAchievement(1, "EQUALOPPORTUNITY")
		end
		
		if (m_sor_count > 0) and (f_sor_count > 0) then
			Achievements.AwardAchievement(1, "EQUALOPPORTUNITY")
		end
		
		if hero:GetAttribute("knockGameCount") == 0 and hero:GetAttribute("pickGameCount") == 0 then
			Achievements.AwardAchievement(1, "GATEHACKER")
		end
		
		if hero:GetAttribute("numItemActivations") == 0 then
			Achievements.AwardAchievement(1, "YOUREDOINGITWRONG")
		end
	end,
}

return QuestHandlers