-------------------------------------------------------------------------------
-- ItemActivationTest
--	A lua version of the yes no menu that enables us to left align the text next
--	to the gamepad button graphics, which you cannot do with buttons because 
--	they have no text alignment controls.
-------------------------------------------------------------------------------

use_safeglobals()

local actual_animList = {
	"tentacle_attack_right",
	"tentacle_attack_left",
	"sword_attack_right",
	"sword_attack_left",
	"staff_attack_right",
	"staff_attack_left",
	"shield_attack_right",
	"shield_attack_left",
	"pike_attack_right",
	"pike_attack_left",
	"mace_attack_right",
	"mace_attack_left",
	"gun_attack_right",
	"gun_attack_left",
	"dagger_attack_right",
	"dagger_attack_left",
	"club_attack_right",
	"club_attack_left",
	"claw_attack_right",
	"claw_attack_left",
	"bite_attack_right",
	"bite_attack_left",
	"beak_attack_right",
	"beak_attack_left",
	"axe_attack_right",
	"axe_attack_left",
	"arrow_attack_right",
	"arrow_attack_left",
	"empty_attack_right",
	"empty_attack_left",
	"bucket_attack_left",
	"torch_attack_left",
	"glove_attack_right",
	"glove_attack_left",
	"greathammer_attack_right",
	"greathammer_attack_left",
	"rapier_attack_right",
	"rapier_attack_left",
	"towershield_attack_right",
	"towershield_attack_left",
	"kiteshield_attack_right",
	"kiteshield_attack_left",
	"battleaxe_attack_right",
	"battleaxe_attack_left",
	"katana_attack_right",
	"katana_attack_left",
	"ninjato_attack_right",
	"ninjato_attack_left",
	"acceleration_green_attack_right",
	"acceleration_green_attack_left",
	"acceleration_red_attack_right",
	"acceleration_red_attack_left",
	"acceleration_yellow_attack_right",
	"acceleration_yellow_attack_left",
	"acceleration_blue_attack_right",
	"acceleration_blue_attack_left",
	"acceleration_purple_attack_right",
	"acceleration_purple_attack_left",
	"healing_attack_right",
	"healing_attack_left",
	"mana_green_attack_right",
	"mana_green_attack_left",
	"mana_red_attack_right",
	"mana_red_attack_left",
	"mana_yellow_attack_right",
	"mana_yellow_attack_left",
	"mana_blue_attack_right",
	"mana_blue_attack_left",
	"mana_purple_attack_right",
	"mana_purple_attack_left",
	"poison_acidic_attack_right",
	"poison_acidic_attack_left",
	"poison_draining_attack_right",
	"poison_draining_attack_left",
	"poison_sapping_attack_right",
	"poison_sapping_attack_left",
	"poison_muting_attack_right",
	"poison_muting_attack_left",
	"poison_dulling_attack_right",
	"poison_dulling_attack_left",
	"poison_nerve_attack_right",
	"poison_nerve_attack_left",
	"cape_attack_left",
	"moltenmetal_attack_left",
	"transforming_weapon_attack_right",
	"transforming_weapon_attack_left",
	"dragonsbreath_attack_right",
	"dragonsbreath_attack_left",
	"vampirefangs_attack_right",
	"vampirefangs_attack_left",
	"polarbear_claw_attack_right",
	"polarbear_claw_attack_left",
	"boneclaw_attack_right",
	"boneclaw_attack_left",
	"manarake_attack_right",
	"manarake_attack_left",
	"greatironfist_attack_right",
	"tinybite_attack_right",
	"tinybite_attack_left",
	"hammer_of_righteous_attack_left",
}

local RACES = {
	"Standard",
	"Orcish",
	"BlackIron",
	"DarkElven",
	"Dwarven",
	"Elven",
	"Demonic",
}

local RARITIES = {
	"Normal",
	"Magical",
	"Master",
	"Renowned",
	"Legendary",
}

local ITEM_LIST = {
	Axe								= { baseType = "Axe"},
	BastardSword					= { baseType = "BastardSword"},
	BattleAxe						= { baseType = "BattleAxe"},
	ClawedGlove						= { baseType = "ClawedGlove"},
	Claymore						= { baseType = "Claymore"},
	CompositeBow					= { baseType = "CompositeBow"},
	CrusadeSword					= { baseType = "CrusadeSword"},
	Dagger							= { baseType = "Dagger"},
	Daikatana						= { baseType = "Daikatana"},
	Falcion							= { baseType = "Falcion"},
	FlintlockPistol					= { baseType = "FlintlockPistol"},
	GreatAxe						= { baseType = "GreatAxe"},
	GreatClub						= { baseType = "GreatClub"},
	GreatHammer						= { baseType = "GreatHammer"},
	Greatsword						= { baseType = "Greatsword"},
	Halberd							= { baseType = "Halberd"},
	HolySword						= { baseType = "HolySword"},
	Katana							= { baseType = "Katana"},
	Longbow							= { baseType = "Longbow"},
	LongSword						= { baseType = "LongSword"},
	Mace							= { baseType = "Mace"},
	Morningstar						= { baseType = "Morningstar"},
	Ninjato							= { baseType = "Ninjato"},
	Rapier							= { baseType = "Rapier"},
	Scimitar						= { baseType = "Scimitar"},
	Shortbow						= { baseType = "Shortbow"},
	ShortSword						= { baseType = "ShortSword"},
	SpellStaff						= { baseType = "SpellStaff"},
	ThrowingKnife					= { baseType = "ThrowingKnife"},
	Warhammer						= { baseType = "Warhammer"},
	WitchBlade						= { baseType = "WitchBlade"},
	Zaltir							= { baseType = "Zaltir"},
	Zweihander						= { baseType = "Zweihander"},
	Buckler							= { baseType = "Buckler"},
	RoundShield						= { baseType = "RoundShield"},
	MainGauche						= { baseType = "MainGauche"},
	KiteShield						= { baseType = "KiteShield"},
	TowerShield						= { baseType = "TowerShield"},
	MinorHealingPotion				= { baseType = "MinorHealingPotion"},
	RegularHealingPotion			= { baseType = "RegularHealingPotion"},
	MajorHealingPotion				= { baseType = "MajorHealingPotion"},
	RedManaPotion					= { baseType = "RedManaPotion"},
	BlueManaPotion					= { baseType = "BlueManaPotion"},
	GreenManaPotion					= { baseType = "GreenManaPotion"},
	YellowManaPotion				= { baseType = "YellowManaPotion"},
	BlackManaPotion					= { baseType = "BlackManaPotion"},
	RedManaAccelerationPotion		= { baseType = "RedManaAccelerationPotion"},
	BlueManaAccelerationPotion		= { baseType = "BlueManaAccelerationPotion"},
	GreenManaAccelerationPotion		= { baseType = "GreenManaAccelerationPotion"},
	YellowManaAccelerationPotion	= { baseType = "YellowManaAccelerationPotion"},
	BlackManaAccelerationPotion		= { baseType = "BlackManaAccelerationPotion"},
	ArachnaPoison					= { baseType = "ArachnaPoison"},
	ManticorePoison					= { baseType = "ManticorePoison"},
	WyvernPoison					= { baseType = "WyvernPoison"},

	bite = { uniqueType = "Bite", },
	boneclaw = { uniqueType = "BoneClaw", },
	bullfighterscape = { uniqueType = "BullfightersCape", },
	claw = { uniqueType = "Claw", },
	crushing_bite = { uniqueType = "CrushingBite", },
	dragonsbreath = { uniqueType = "DragonsBreath", },
	etherial_bite = { uniqueType = "EtherialBite", },
	flamingtorch = { uniqueType = "FlamingTorch", },
	greatironfist = { uniqueType = "GreatIronFist", },
	hammer_of_righteous = { uniqueType = "HammerOfTheRighteous", },
	kuraks_claw = { uniqueType = "KuraksClaw", },
	manarake = { uniqueType = "ManaRake", },
	massive_bite = { uniqueType = "MassiveBite", },
	massive_claw = { uniqueType = "MassiveClaw", },
	moltenmetal = { uniqueType = "MoltenMetal", },
	owlbearbeak = { uniqueType = "OwlbearBeak", },
	poison_claw = { uniqueType = "PoisonousClaw", },
	polarbear_claw = { uniqueType = "PolarBearClaw", },
	RabidBite = { uniqueType = "RabidBite", },
	RabidCrushingBite = { uniqueType = "RabidCrushingBite", },
	tentacleLash = { uniqueType = "TentacleLash", },
	tinybite = { uniqueType = "TinyBite", },
	tinyclaw = { uniqueType = "TinyClaw", },
	transforming_weapon = { uniqueType = "TransformingWeapon", },
	vampirefangs = { uniqueType = "VampireFangs", },
	venomouspeck = { uniqueType = "VenomousPeck", },
	waterBucket = { uniqueType = "WaterBucket", },
	werewolfclaw = { uniqueType = "WerewolfClaw", },

}

local MONSTERS_LIST = {
	"img_blank",
	"portrait_AssassinF",
	"portrait_AssassinM",
	"portrait_BarbarianF",
	"portrait_BarbarianM",
	"portrait_InquisitorF",
	"portrait_InquisitorM",
	"portrait_WarMageF",
	"portrait_WarMageM",
	"portrait_2HeadedOgre",
	"portrait_ArchLich",
	"portrait_Basilisk",
	"portrait_BlackIronGolem",
	"portrait_BoneWraith",
	"portrait_Brek",
	"portrait_Cockatrice",
	"portrait_CorruptedOrc",
	"portrait_CorruptedOrcBerserker",
	"portrait_CorruptedOrcChieftan",
	"portrait_CorruptedOrcShaman",
	"portrait_CorruptedOrcWolfMaster",
	"portrait_CorruptedSpiritWolf",
	"portrait_DarkElvenAssassin",
	"portrait_DarkElvenCommander",
	"portrait_DarkElvenWarMage",
	"portrait_DarkElvenWarrior",
	"portrait_Gathar",
	"portrait_GelatinousCube",
	"portrait_Ghost",
	"portrait_Ghoul",
	"portrait_GiantTundraWolf",
	"portrait_Goblin",
	"portrait_GoblinBoss",
	"portrait_GoblinRatKeeper",
	"portrait_GoblinWitch",
	"portrait_GoblinWizard",
	"portrait_Gorgon1",
	"portrait_Gorgon2",
	"portrait_GreaterDemon",
	"portrait_GreenDragon",
	"portrait_Hellhound",
	"portrait_KingGodd",
	"portrait_Kurak",
	"portrait_Leprechaun",
	"portrait_Lich",
	"portrait_Manticore",
	"portrait_Medusa",
	"portrait_Minotaur",
	"portrait_Mummy",
	"portrait_Necromancer",
	"portrait_Ogre",
	"portrait_Orc",
	"portrait_OrcBerserker",
	"portrait_OrcChieftan",
	"portrait_OrcShaman",
	"portrait_OrcWolfMaster",
	"portrait_Owlbear",
	"portrait_PolarBear",
	"portrait_RabidGiantTundraWolf",
	"portrait_RabidTundraWolf",
	"portrait_RabidTundraWolf",
	"portrait_Rakshasa",
	"portrait_Raltheia",
	"portrait_RatSwarm",
	"portrait_Shadowbringer",
	"portrait_ShadowTundraWolf",
	"portrait_SkeletonWarrior",
	"portrait_Skeleton",
	"portrait_Troll",
	"portrait_TundraWolf",
	"portrait_Vampire",
	"portrait_VampireLord",
	"portrait_VampiricMist",
	"portrait_Werewolf",
	"portrait_Wraith",
	"portrait_Yeti",
	"portrait_Zombie",
}

local SECTION_MONSTERS = 1
local SECTION_ITEMS = 2

local SECTIONS = {
	"monsters",
	"item",
}

class "ItemActivationTest" (Menu);

function ItemActivationTest:__init()
	super()
	
	self:Initialize("Assets\\Screens\\ItemActivationTest.xml")
end

function ItemActivationTest:OnOpen()
	self:reset_list("drop_list_monsters")
	for _, name in pairs(MONSTERS_LIST) do
		self:set_list_option("drop_list_monsters", name)
	end
	self.monsterIndex = 1
	
	self:reset_list("drop_list_item")
	for name, data in pairs(ITEM_LIST) do
		self:set_list_option("drop_list_item", name)
	end
	self.itemIndex = 1
	
	self:set_alpha("icon_monster_black", 0.5)
	self:set_alpha("icon_item_black", 0.5)

	self.section = SECTION_MONSTERS
	self:SelectListbox()

	return Menu.OnOpen(self)
end

function ItemActivationTest:ShiftRight()
	self.section = self.section + 1
	if self.section > #SECTIONS then
		self.section = 1
	end
	-- update listbox selection
	self:SelectListbox()
end

function ItemActivationTest:ShiftLeft()
	self.section = self.section - 1
	if self.section < 1 then
		self.section = #SECTIONS
	end
	-- update listbox selection
	self:SelectListbox()
end

function ItemActivationTest:SelectListbox()
	assert(self.section)
	self:activate_widget("icon_monster_black")
	self:activate_widget("icon_item_black")
	self:hide_widget(string.format("icon_%s_black", SECTIONS[self.section]))
	MenuSystem.SetGamepadWidget(self, string.format("drop_list_%s",SECTIONS[self.section]))
end

function ItemActivationTest:AnimExists(itemAnimation)
	for k,animName in ipairs(actual_animList) do
		if animName == itemAnimation then
			return true
		end
	end
	
	return false
end

function ItemActivationTest:OnButton(button_id, x, y)
	if button_id == self:get_widget_id("butt_left") then
		-- Play left
		self:TriggerAnimation(1)
	elseif button_id == self:get_widget_id("butt_right") then
		-- Play right
		self:TriggerAnimation(2)
	elseif button_id == self:get_widget_id("butt_cancel") then
		self:Close()
	end
	
	return Menu.MESSAGE_HANDLED
end

function ItemActivationTest:OnGamepadButton(user_id, button_id, value)
	if (value == 0) and (button_id ~= Gamepad.MapGenericInput(user_id, GamepadInput.GAMEPAD_BUTTON_START)) then
		return Menu.MESSAGE_HANDLED
	end
	
	if button_id == Gamepad.MapGenericInput(user_id, GamepadInput.GAMEPAD_BUTTON_CROSS_LEFT) then
		-- Play left
		self:TriggerAnimation(1)
	elseif button_id == Gamepad.MapGenericInput(user_id, GamepadInput.GAMEPAD_BUTTON_CROSS_TOP) then
		-- Play right
		self:TriggerAnimation(2)
	elseif button_id == Gamepad.MapGenericInput(user_id, GamepadInput.GAMEPAD_BUTTON_SHOULDER_LEFT) then
		self:ShiftLeft()
	elseif button_id == Gamepad.MapGenericInput(user_id, GamepadInput.GAMEPAD_BUTTON_SHOULDER_RIGHT) then
		self:ShiftRight()
	elseif button_id == Gamepad.MapGenericInput(user_id, GamepadInput.GAMEPAD_BUTTON_CANCEL) then
		self:Close()
	end
	
	return Menu.MESSAGE_HANDLED
end

local function CreateItem(itemInfo)
	local level = 25

	if itemInfo.uniqueType then
		return CreateUniqueItem(itemInfo.uniqueType, level)
	else
		local item = GameObjectManager:ConstructLocal("ITEQ")
		local race_type = RACES[math.random(#RACES)]
		local rarity_type = RARITIES[math.random(#RARITIES)]

		item:InitItem(itemInfo.baseType, race_type, rarity_type, level)
		return item
	end
end

function ItemActivationTest:TriggerAnimation(playerIndex)

	-- This menu blocks any interaction with the PlayerInfoMenu's or BattleGameMenu while 
	-- the item effect is active. We dont want any popups, accidental button presses, etc
	-- This menu also defines all animations
	SCREENS.ItemActivationMenu:Open()

	local damage = 0
	local defence = 0
	local missed = false
	local health = 0
	local mana = 0
	local manamatch = 0
	local damageturn = 0
	local critical = false

	local playerPortrait = self:get_list_option("drop_list_monsters")
	if playerPortrait ~= "img_blank" then
		playerPortrait = string.format("%s_A",playerPortrait)
	end
	
	local item = self:get_list_option("drop_list_item")
	local itemUsed = CreateItem(ITEM_LIST[item])
	local itemAnimation = itemUsed:GetActivationAnimation()
	
	self:set_text("str_animName", itemAnimation)
	
	if itemUsed:IsWeapon() then
		damage = itemUsed:GetDamageBase()
		critical = (math.random(100) < 50)
	elseif itemUsed:IsShield() then
		defence = 20
		critical = (math.random(100) < 50)
	end
	
	local value = itemUsed:GetActivationValue()
	if itemUsed:IsHealthPotion() then
		health = value
	elseif itemUsed:IsManaPotion() then
		mana = value
	elseif itemUsed:IsManaAccelerant() then
		manamatch = value
	elseif itemUsed:IsPoison() then
		damageturn = value
	end
	
	-- Set the backdrop
	local backdrop = "img_backdrop_icecaves"

	for i=0,1 do
		for j=0,1 do
			SCREENS.ItemActivationMenu:set_image(string.format("icon_level_backdrop%d%d", i, j), string.format("%s%d%d", backdrop, i, j))
		end
	end
	
	if playerIndex == 1 then 
		if not self:AnimExists(string.format("%s_left", itemAnimation)) then
			open_message_menu("", string.format("Animation '%s_left' does not exist", itemAnimation))
			SCREENS.ItemActivationMenu:Close()
			return
		end
		SCREENS.ItemActivationMenu:StartAnimation(string.format("%s_left", itemAnimation))
		SCREENS.ItemActivationMenu:set_font("str_damage_left", "font_msg_green")
		SCREENS.ItemActivationMenu:set_text_raw("str_weapon_left",string.upper(itemUsed:GetName()))
		SCREENS.ItemActivationMenu:set_image("icon_portrait_left", playerPortrait)
		
		if critical then
			SoundSystem.Play("pq2audio/board/fx_critical")
			SCREENS.ItemActivationMenu:set_text("str_critical_left", "[CRITICAL_ITEM]")
		else
			SCREENS.ItemActivationMenu:set_text_raw("str_critical_left", "")
		end
		
		if (damage > 0) then
			SCREENS.ItemActivationMenu:set_text_raw("str_damage_left",substitute(translate_text("[ITEM_DOES_DAMAGE_AMOUNT]"), damage))
		elseif missed then
			SCREENS.ItemActivationMenu:set_text_raw("str_damage_left",translate_text("[ITEM_MISSED]"))
		elseif (defence > 0) then
			SCREENS.ItemActivationMenu:set_text_raw("str_damage_left",substitute(translate_text("[ITEM_INCREASES_DEFENCE_AMOUNT]"), defence))
		elseif (health > 0) then
			SCREENS.ItemActivationMenu:set_text_raw("str_damage_left",substitute(translate_text("[ITEM_INCREASES_HEALTH_AMOUNT]"), health))
		elseif (mana > 0) then
			SCREENS.ItemActivationMenu:set_text_raw("str_damage_left",substitute(translate_text("[ITEM_INCREASES_MANA_AMOUNT]"), mana))
		elseif (manamatch > 0) then
			SCREENS.ItemActivationMenu:set_text_raw("str_damage_left",substitute(translate_text("[ITEM_INCREASES_MANAMATCH_AMOUNT]"), manamatch))
		elseif (damageturn > 0) then
			SCREENS.ItemActivationMenu:set_text_raw("str_damage_left",substitute(translate_text("[ITEM_INCREASES_DAMAGETURN_AMOUNT]"), damageturn))
		else
			SCREENS.ItemActivationMenu:set_text_raw("str_damage_left", "")
		end
		
		if itemAnimation == "sword_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_sword_left", "img_combatbanner_sword")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing1_left", "img_combatbanner_sword_swing_1")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing2_left", "img_combatbanner_sword_swing_2")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing3_left", "img_combatbanner_sword_swing_3")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing4_left", "img_combatbanner_sword_swing_4")
			SCREENS.ItemActivationMenu:set_image("icon_shine_left", "img_combatbanner_sword_shine")
			SoundSystem.Play("pq2audio/atk/atk_sword")
		elseif itemAnimation == "claw_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_claw_left", "img_combatbanner_claw")
			SoundSystem.Play("pq2audio/atk/atk_claw")
		elseif itemAnimation == "staff_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_staff_left", "img_combatbanner_staff")
			SoundSystem.Play("pq2audio/atk/atk_staff")
		elseif itemAnimation == "arrow_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_arrow1_left", "img_combatbanner_arrow")	
			SCREENS.ItemActivationMenu:set_image("icon_arrow2_left", "img_combatbanner_arrow")	
			SCREENS.ItemActivationMenu:set_image("icon_arrow3_left", "img_combatbanner_arrow")	
			SCREENS.ItemActivationMenu:set_image("icon_arrow4_left", "img_combatbanner_arrow")	
			SCREENS.ItemActivationMenu:set_image("icon_arrow5_left", "img_combatbanner_arrow")	
			SCREENS.ItemActivationMenu:set_image("icon_arrow6_left", "img_combatbanner_arrow")
			SCREENS.ItemActivationMenu:set_image("icon_arrow7_left", "img_combatbanner_arrow")
			SoundSystem.Play("pq2audio/atk/atk_arrow")
		elseif itemAnimation == "beak_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_beak_left", "img_combatbanner_beak")
			SoundSystem.Play("pq2audio/atk/atk_beak")
		elseif itemAnimation == "bite_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_bite_left", "img_combatbanner_bite")
			SoundSystem.Play("pq2audio/atk/atk_bite")
		elseif itemAnimation == "tentacle_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_tentacle1_left", "img_combatbanner_tentacle_1")	
			SCREENS.ItemActivationMenu:set_image("icon_tentacle2_left", "img_combatbanner_tentacle_2")	
			SCREENS.ItemActivationMenu:set_image("icon_tentacle3_left", "img_combatbanner_tentacle_3")
			SoundSystem.Play("pq2audio/atk/atk_tentacle")
		elseif itemAnimation == "dagger_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_dagger_left", "img_combatbanner_dagger")
			SoundSystem.Play("pq2audio/atk/atk_dagger")
		elseif itemAnimation == "mace_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_mace_left", "img_combatbanner_mace")
			SoundSystem.Play("pq2audio/atk/atk_mace")
		elseif itemAnimation == "shield_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_shield_left", "img_combatbanner_shield")
			SoundSystem.Play("pq2audio/atk/atk_shield")
		elseif itemAnimation == "axe_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_axe_left", "img_combatbanner_axe")
			SoundSystem.Play("pq2audio/atk/atk_axe")
		elseif itemAnimation == "pike_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_pike_left", "img_combatbanner_pike")
			SoundSystem.Play("pq2audio/atk/atk_polearm")
		elseif itemAnimation == "gun_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_gun_left", "img_combatbanner_gun")	
			SCREENS.ItemActivationMenu:set_image("icon_gun_shot_left", "img_combatbanner_gun_fire")	
			SCREENS.ItemActivationMenu:set_image("icon_gun_smoke1_left", "img_combatbanner_gun_smoke1")	
			SCREENS.ItemActivationMenu:set_image("icon_gun_smoke2_left", "img_combatbanner_gun_smoke2")
			SCREENS.ItemActivationMenu:set_image("icon_gun_smoke3_left", "img_combatbanner_gun_smoke3")
			SoundSystem.Play("pq2audio/atk/atk_gun")
		elseif itemAnimation == "club_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_club_left", "img_combatbanner_club")
			SoundSystem.Play("pq2audio/atk/atk_club")
		elseif itemAnimation == "greathammer_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_greathammer_left", "img_combatbanner_greathammer")
			SoundSystem.Play("pq2audio/atk/atk_greathammer")
		elseif itemAnimation == "glove_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_glove_left", "img_combatbanner_clawed_glove")
			SoundSystem.Play("pq2audio/atk/atk_clawedglove")
		elseif itemAnimation == "rapier_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_rapier1_left", "img_combatbanner_rapier1")
			SCREENS.ItemActivationMenu:set_image("icon_rapier2_left", "img_combatbanner_rapier2")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing1_left", "img_combatbanner_sword_swing_1")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing2_left", "img_combatbanner_sword_swing_2")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing3_left", "img_combatbanner_sword_swing_3")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing4_left", "img_combatbanner_sword_swing_4")
			SCREENS.ItemActivationMenu:set_image("icon_shine_left", "img_combatbanner_sword_shine")
			SoundSystem.Play("pq2audio/atk/atk_rapier")
		elseif itemAnimation == "towershield_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_towershield_left", "img_combatbanner_towershield")
			SoundSystem.Play("pq2audio/atk/atk_towershield")
		elseif itemAnimation == "kiteshield_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_kiteshield_left", "img_combatbanner_kiteshield")
			SoundSystem.Play("pq2audio/atk/atk_kiteshield")	
		elseif itemAnimation == "battleaxe_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_battleaxe_left", "img_combatbanner_battleaxe")
			SoundSystem.Play("pq2audio/atk/atk_axe")
		elseif itemAnimation == "katana_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_katana1_left", "img_combatbanner_katana1")
			SCREENS.ItemActivationMenu:set_image("icon_katana2_left", "img_combatbanner_katana2")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing1_left", "img_combatbanner_sword_swing_1")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing2_left", "img_combatbanner_sword_swing_2")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing3_left", "img_combatbanner_sword_swing_3")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing4_left", "img_combatbanner_sword_swing_4")
			SCREENS.ItemActivationMenu:set_image("icon_shine_left", "img_combatbanner_sword_shine")
			SoundSystem.Play("pq2audio/atk/atk_katana")
		elseif itemAnimation == "ninjato_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_ninjato1_left", "img_combatbanner_ninjato1")
			SCREENS.ItemActivationMenu:set_image("icon_ninjato2_left", "img_combatbanner_ninjato2")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing1_left", "img_combatbanner_sword_swing_1")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing2_left", "img_combatbanner_sword_swing_2")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing3_left", "img_combatbanner_sword_swing_3")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing4_left", "img_combatbanner_sword_swing_4")
			SCREENS.ItemActivationMenu:set_image("icon_shine_left", "img_combatbanner_sword_shine")
			SoundSystem.Play("pq2audio/atk/atk_katana")
		elseif itemAnimation == "acceleration_green_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_acceleration_potion_left", "img_combatbanner_acceleration_green")
			SoundSystem.Play("pq2audio/atk/atk_manaaccel")
		elseif itemAnimation == "acceleration_red_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_acceleration_potion_left", "img_combatbanner_acceleration_red")
			SoundSystem.Play("pq2audio/atk/atk_manaaccel")
		elseif itemAnimation == "acceleration_yellow_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_acceleration_potion_left", "img_combatbanner_acceleration_yellow")
			SoundSystem.Play("pq2audio/atk/atk_manaaccel")	
		elseif itemAnimation == "acceleration_blue_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_acceleration_potion_left", "img_combatbanner_acceleration_blue")
			SoundSystem.Play("pq2audio/atk/atk_manaaccel")
		elseif itemAnimation == "acceleration_purple_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_acceleration_potion_left", "img_combatbanner_acceleration_purple")
			SoundSystem.Play("pq2audio/atk/atk_manaaccel")
		elseif itemAnimation == "healing_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_healing_potion_left", "img_combatbanner_healthpotion")
			SoundSystem.Play("pq2audio/atk/atk_healing")
		elseif itemAnimation == "mana_green_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_mana_potion_left", "img_combatbanner_mana_green")
			SoundSystem.Play("pq2audio/atk/atk_manapotion")
		elseif itemAnimation == "mana_red_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_mana_potion_left", "img_combatbanner_mana_red")
			SoundSystem.Play("pq2audio/atk/atk_manapotion")
		elseif itemAnimation == "mana_yellow_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_mana_potion_left", "img_combatbanner_mana_yellow")
			SoundSystem.Play("pq2audio/atk/atk_manapotion")	
		elseif itemAnimation == "mana_blue_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_mana_potion_left", "img_combatbanner_mana_blue")
			SoundSystem.Play("pq2audio/atk/atk_manapotion")
		elseif itemAnimation == "mana_purple_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_mana_potion_left", "img_combatbanner_mana_purple")
			SoundSystem.Play("pq2audio/atk/atk_manapotion")
		elseif itemAnimation == "poison_acidic_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_poison_left", "img_combatbanner_poison_acidic")
			SoundSystem.Play("pq2audio/atk/atk_poison")
		elseif itemAnimation == "poison_draining_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_poison_left", "img_combatbanner_poison_draining")
			SoundSystem.Play("pq2audio/atk/atk_poison")
		elseif itemAnimation == "poison_sapping_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_poison_left", "img_combatbanner_poison_sapping")
			SoundSystem.Play("pq2audio/atk/atk_poison")
		elseif itemAnimation == "poison_muting_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_poison_left", "img_combatbanner_poison_muting")
			SoundSystem.Play("pq2audio/atk/atk_poison")
		elseif itemAnimation == "poison_dulling_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_poison_left", "img_combatbanner_poison_dulling")
			SoundSystem.Play("pq2audio/atk/atk_poison")
		elseif itemAnimation == "poison_nerve_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_poison_left", "img_combatbanner_poison_nerve")
			SoundSystem.Play("pq2audio/atk/atk_poison")
		elseif itemAnimation == "transforming_weapon_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_transforming_weapon_left", "img_combatbanner_transforming_weapon")
			SoundSystem.Play("pq2audio/atk/atk_transforming")
		elseif itemAnimation == "dragonsbreath_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_dragonsbreath1_left", "img_combatbanner_dragonsbreath1")
			SCREENS.ItemActivationMenu:set_image("icon_dragonsbreath2_left", "img_combatbanner_dragonsbreath2")
			SoundSystem.Play("pq2audio/atk/atk_dragonbreath")
		elseif itemAnimation == "vampirefangs_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_vampirefangs_left", "img_combatbanner_vampirefangs")
			SoundSystem.Play("pq2audio/atk/atk_vampirefangs")
		elseif itemAnimation == "polarbear_claw_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_polarbear_claw_left", "img_combatbanner_polarbear_claw")
			SoundSystem.Play("pq2audio/atk/atk_polarbearclaw")
		elseif itemAnimation == "boneclaw_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_boneclaw_left", "img_combatbanner_boneclaw")
			SoundSystem.Play("pq2audio/atk/atk_boneclaw")		
		elseif itemAnimation == "manarake_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_manarake_left", "img_combatbanner_mana_rake")
			SoundSystem.Play("pq2audio/atk/atk_claw")		
		elseif itemAnimation == "greatronfist_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_greatironfist1_left", "img_combatbanner_greatironfist1")
			SCREENS.ItemActivationMenu:set_image("icon_greatironfist2_left", "img_combatbanner_greatironfist2")
			SoundSystem.Play("pq2audio/atk/atk_greatironfist")	
		elseif itemAnimation == "tinybite_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_tinybite_left", "img_combatbanner_tinybite")
			SoundSystem.Play("pq2audio/atk/atk_tinybite")	

	
		-- Challenge Room Weapons, these only appear for the left side  
		elseif itemAnimation == "bucket_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_bucket_left", "img_combatbanner_waterbucket")
			SoundSystem.Play("pq2audio/atk/atk_waterbucket")
		elseif itemAnimation == "torch_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_torch_left", "img_combatbanner_torch")
			SoundSystem.Play("pq2audio/atk/atk_flamingtorch")
		elseif itemAnimation == "cape_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_cape_left", "img_combatbanner_cape")
			SoundSystem.Play("pq2audio/atk/atk_cape")
		elseif itemAnimation == "moltenmetal_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_moltenmetal_left", "img_combatbanner_molten_metal")
			SoundSystem.Play("pq2audio/atk/atk_moltenmetal")
		elseif itemAnimation == "hammer_of_righteous_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_hammer_of_righteous_left", "img_combatbanner_hammer_of_the_righteous")
			SoundSystem.Play("pq2audio/atk/atk_hammerofrighteous")			
	
		end
		
	else 
		if not self:AnimExists(string.format("%s_right", itemAnimation)) then
			open_message_menu("", string.format("Animation '%s_right' does not exist", itemAnimation))
			SCREENS.ItemActivationMenu:Close()
			return
		end

		SCREENS.ItemActivationMenu:StartAnimation(string.format("%s_right", itemAnimation))
		SCREENS.ItemActivationMenu:set_font("str_damage_right", "font_msg_red") 
		SCREENS.ItemActivationMenu:set_text_raw("str_weapon_right",string.upper(itemUsed:GetName()))
		SCREENS.ItemActivationMenu:set_image("icon_portrait_right", playerPortrait)
		
		if critical then
			SoundSystem.Play("pq2audio/board/fx_critical")
			SCREENS.ItemActivationMenu:set_text("str_critical_right", "[CRITICAL_ITEM]")
		else
			SCREENS.ItemActivationMenu:set_text_raw("str_critical_right", "")
		end
		
		if (damage > 0) then
			SCREENS.ItemActivationMenu:set_text_raw("str_damage_right",substitute(translate_text("[ITEM_DOES_DAMAGE_AMOUNT]"), damage))
		elseif missed then
			SCREENS.ItemActivationMenu:set_text_raw("str_damage_right",translate_text("[ITEM_MISSED]"))
		elseif (defence > 0) then
			SCREENS.ItemActivationMenu:set_text_raw("str_damage_right",substitute(translate_text("[ITEM_INCREASES_DEFENCE_AMOUNT]"), defence))
		elseif (health > 0) then
			SCREENS.ItemActivationMenu:set_text_raw("str_damage_right",substitute(translate_text("[ITEM_INCREASES_HEALTH_AMOUNT]"), health))
		elseif (mana > 0) then
			SCREENS.ItemActivationMenu:set_text_raw("str_damage_right",substitute(translate_text("[ITEM_INCREASES_MANA_AMOUNT]"), mana))
		elseif (manamatch > 0) then
			SCREENS.ItemActivationMenu:set_text_raw("str_damage_right",substitute(translate_text("[ITEM_INCREASES_MANAMATCH_AMOUNT]"), manamatch))
		elseif (damageturn > 0) then
			SCREENS.ItemActivationMenu:set_text_raw("str_damage_right",substitute(translate_text("[ITEM_INCREASES_DAMAGETURN_AMOUNT]"), damageturn))
		else
			SCREENS.ItemActivationMenu:set_text_raw("str_damage_right", "")
		end
		
		if itemAnimation == "sword_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_sword_right", "img_combatbanner_sword")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing1_right", "img_combatbanner_sword_swing_1")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing2_right", "img_combatbanner_sword_swing_2")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing3_right", "img_combatbanner_sword_swing_3")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing4_right", "img_combatbanner_sword_swing_4")
			SCREENS.ItemActivationMenu:set_image("icon_shine_right", "img_combatbanner_sword_shine")
			SoundSystem.Play("pq2audio/atk/atk_sword")
		elseif itemAnimation == "claw_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_claw_right", "img_combatbanner_claw")
			SoundSystem.Play("pq2audio/atk/atk_claw")
		elseif itemAnimation == "staff_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_staff_right", "img_combatbanner_staff")
			SoundSystem.Play("pq2audio/atk/atk_staff")
		elseif itemAnimation == "arrow_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_arrow1_right", "img_combatbanner_arrow")	
			SCREENS.ItemActivationMenu:set_image("icon_arrow2_right", "img_combatbanner_arrow")	
			SCREENS.ItemActivationMenu:set_image("icon_arrow3_right", "img_combatbanner_arrow")	
			SCREENS.ItemActivationMenu:set_image("icon_arrow4_right", "img_combatbanner_arrow")	
			SCREENS.ItemActivationMenu:set_image("icon_arrow5_right", "img_combatbanner_arrow")	
			SCREENS.ItemActivationMenu:set_image("icon_arrow6_right", "img_combatbanner_arrow")	
			SCREENS.ItemActivationMenu:set_image("icon_arrow7_right", "img_combatbanner_arrow")
			SoundSystem.Play("pq2audio/atk/atk_arrow")
		elseif itemAnimation == "beak_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_beak_right", "img_combatbanner_beak")
			SoundSystem.Play("pq2audio/atk/atk_beak")
		elseif itemAnimation == "bite_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_bite_right", "img_combatbanner_bite")
			SoundSystem.Play("pq2audio/atk/atk_bite")
		elseif itemAnimation == "tentacle_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_tentacle1_right", "img_combatbanner_tentacle_1")	
			SCREENS.ItemActivationMenu:set_image("icon_tentacle2_right", "img_combatbanner_tentacle_2")	
			SCREENS.ItemActivationMenu:set_image("icon_tentacle3_right", "img_combatbanner_tentacle_3")
			SoundSystem.Play("pq2audio/atk/atk_tentacle")
		elseif itemAnimation == "dagger_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_dagger_right", "img_combatbanner_dagger")
			SoundSystem.Play("pq2audio/atk/atk_dagger")
		elseif itemAnimation == "mace_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_mace_right", "img_combatbanner_mace")
			SoundSystem.Play("pq2audio/atk/atk_mace")
		elseif itemAnimation == "shield_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_shield_right", "img_combatbanner_shield")
			SoundSystem.Play("pq2audio/atk/atk_shield")
		elseif itemAnimation == "axe_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_axe_right", "img_combatbanner_axe")
			SoundSystem.Play("pq2audio/atk/atk_axe")
		elseif itemAnimation == "pike_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_pike_right", "img_combatbanner_pike")
			SoundSystem.Play("pq2audio/atk/atk_polearm")
		elseif itemAnimation == "gun_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_gun_right", "img_combatbanner_gun")	
			SCREENS.ItemActivationMenu:set_image("icon_gun_shot_right", "img_combatbanner_gun_fire")	
			SCREENS.ItemActivationMenu:set_image("icon_gun_smoke1_right", "img_combatbanner_gun_smoke1")	
			SCREENS.ItemActivationMenu:set_image("icon_gun_smoke2_right", "img_combatbanner_gun_smoke2")
			SCREENS.ItemActivationMenu:set_image("icon_gun_smoke3_right", "img_combatbanner_gun_smoke3")
			SoundSystem.Play("pq2audio/atk/atk_gun")
		elseif itemAnimation == "club_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_club_right", "img_combatbanner_club")
			SoundSystem.Play("pq2audio/atk/atk_club")
		elseif itemAnimation == "greathammer_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_greathammer_right", "img_combatbanner_greathammer")
			SoundSystem.Play("pq2audio/atk/atk_greathammer")
		elseif itemAnimation == "glove_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_glove_right", "img_combatbanner_clawed_glove")
			SoundSystem.Play("pq2audio/atk/atk_clawedglove")
		elseif itemAnimation == "rapier_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_rapier1_right", "img_combatbanner_rapier1")
			SCREENS.ItemActivationMenu:set_image("icon_rapier2_right", "img_combatbanner_rapier2")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing1_right", "img_combatbanner_sword_swing_1")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing2_right", "img_combatbanner_sword_swing_2")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing3_right", "img_combatbanner_sword_swing_3")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing4_right", "img_combatbanner_sword_swing_4")
			SCREENS.ItemActivationMenu:set_image("icon_shine_right", "img_combatbanner_sword_shine")
			SoundSystem.Play("pq2audio/atk/atk_rapier")
		elseif itemAnimation == "towershield_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_towershield_right", "img_combatbanner_towershield")
			SoundSystem.Play("pq2audio/atk/atk_towershield")
		elseif itemAnimation == "kiteshield_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_kiteshield_right", "img_combatbanner_kiteshield")
			SoundSystem.Play("pq2audio/atk/atk_kiteshield")
		elseif itemAnimation == "battleaxe_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_battleaxe_right", "img_combatbanner_battleaxe")
			SoundSystem.Play("pq2audio/atk/atk_axe")
		elseif itemAnimation == "katana_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_katana1_right", "img_combatbanner_katana1")
			SCREENS.ItemActivationMenu:set_image("icon_katana2_right", "img_combatbanner_katana2")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing1_right", "img_combatbanner_sword_swing_1")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing2_right", "img_combatbanner_sword_swing_2")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing3_right", "img_combatbanner_sword_swing_3")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing4_right", "img_combatbanner_sword_swing_4")
			SCREENS.ItemActivationMenu:set_image("icon_shine_right", "img_combatbanner_sword_shine")
			SoundSystem.Play("pq2audio/atk/atk_katana")
		elseif itemAnimation == "ninjato_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_ninjato1_right", "img_combatbanner_ninjato1")
			SCREENS.ItemActivationMenu:set_image("icon_ninjato2_right", "img_combatbanner_ninjato2")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing1_right", "img_combatbanner_sword_swing_1")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing2_right", "img_combatbanner_sword_swing_2")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing3_right", "img_combatbanner_sword_swing_3")
			SCREENS.ItemActivationMenu:set_image("icon_sword_swing4_right", "img_combatbanner_sword_swing_4")
			SCREENS.ItemActivationMenu:set_image("icon_shine_right", "img_combatbanner_sword_shine")
			SoundSystem.Play("pq2audio/atk/atk_katana")
		elseif itemAnimation == "acceleration_green_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_acceleration_potion_right", "img_combatbanner_acceleration_green")
			SoundSystem.Play("pq2audio/atk/atk_manaaccel")
		elseif itemAnimation == "acceleration_red_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_acceleration_potion_right", "img_combatbanner_acceleration_red")
			SoundSystem.Play("pq2audio/atk/atk_manaaccel")
		elseif itemAnimation == "acceleration_yellow_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_acceleration_potion_right", "img_combatbanner_acceleration_yellow")
			SoundSystem.Play("pq2audio/atk/atk_manaaccel")	
		elseif itemAnimation == "acceleration_blue_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_acceleration_potion_right", "img_combatbanner_acceleration_blue")
			SoundSystem.Play("pq2audio/atk/atk_manaaccel")
		elseif itemAnimation == "acceleration_purple_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_acceleration_potion_right", "img_combatbanner_acceleration_purple")
			SoundSystem.Play("pq2audio/atk/atk_manaaccel")
		elseif itemAnimation == "healing_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_healing_potion_right", "img_combatbanner_healthpotion")
			SoundSystem.Play("pq2audio/atk/atk_healing")
		elseif itemAnimation == "mana_green_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_mana_potion_right", "img_combatbanner_mana_green")
			SoundSystem.Play("pq2audio/atk/atk_manapotion")
		elseif itemAnimation == "mana_red_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_mana_potion_right", "img_combatbanner_mana_red")
			SoundSystem.Play("pq2audio/atk/atk_manapotion")
		elseif itemAnimation == "mana_yellow_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_mana_potion_right", "img_combatbanner_mana_yellow")
			SoundSystem.Play("pq2audio/atk/atk_manapotion")	
		elseif itemAnimation == "mana_blue_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_mana_potion_right", "img_combatbanner_mana_blue")
			SoundSystem.Play("pq2audio/atk/atk_manapotion")
		elseif itemAnimation == "mana_purple_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_mana_potion_right", "img_combatbanner_mana_purple")
			SoundSystem.Play("pq2audio/atk/atk_manapotion")
		elseif itemAnimation == "poison_acidic_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_poison_right", "img_combatbanner_poison_acidic")
			SoundSystem.Play("pq2audio/atk/atk_poison")
		elseif itemAnimation == "poison_draining_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_poison_right", "img_combatbanner_poison_draining")
			SoundSystem.Play("pq2audio/atk/atk_poison")
		elseif itemAnimation == "poison_sapping_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_poison_right", "img_combatbanner_poison_sapping")
			SoundSystem.Play("pq2audio/atk/atk_poison")
		elseif itemAnimation == "poison_muting_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_poison_right", "img_combatbanner_poison_muting")
			SoundSystem.Play("pq2audio/atk/atk_poison")
		elseif itemAnimation == "poison_dulling_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_poison_right", "img_combatbanner_poison_dulling")
			SoundSystem.Play("pq2audio/atk/atk_poison")
		elseif itemAnimation == "poison_nerve_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_poison_right", "img_combatbanner_poison_nerve")
			SoundSystem.Play("pq2audio/atk/atk_poison")
		elseif itemAnimation == "transforming_weapon_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_transforming_weapon_right", "img_combatbanner_transforming_weapon")
			SoundSystem.Play("pq2audio/atk/atk_transforming")
		elseif itemAnimation == "dragonsbreath_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_dragonsbreath1_right", "img_combatbanner_dragons_breath1")
			SCREENS.ItemActivationMenu:set_image("icon_dragonsbreath2_right", "img_combatbanner_dragons_breath2")
			SoundSystem.Play("pq2audio/atk/atk_dragonbreath")
		elseif itemAnimation == "vampirefangs_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_vampirefangs_right", "img_combatbanner_vampirefangs")
			SoundSystem.Play("pq2audio/atk/atk_vampirefangs")
		elseif itemAnimation == "polarbear_claw_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_polarbear_claw_right", "img_combatbanner_polarbear_claw")
			SoundSystem.Play("pq2audio/atk/atk_polarbearclaw")
		elseif itemAnimation == "boneclaw_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_boneclaw_right", "img_combatbanner_boneclaw")
			SoundSystem.Play("pq2audio/atk/atk_boneclaw")
		elseif itemAnimation == "manarake_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_manarake_right", "img_combatbanner_mana_rake")
			SoundSystem.Play("pq2audio/atk/atk_claw")
		elseif itemAnimation == "greatironfist_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_greatironfist1_right", "img_combatbanner_greatironfist1")
			SCREENS.ItemActivationMenu:set_image("icon_greatironfist2_right", "img_combatbanner_greatironfist2")
			SoundSystem.Play("pq2audio/atk/atk_greatironfist")
		elseif itemAnimation == "tinybite_attack" then
			SCREENS.ItemActivationMenu:set_image("icon_tinybite_right", "img_combatbanner_tinybite")
			SoundSystem.Play("pq2audio/atk/atk_tinybite")
			
		end
	end	
		
end	


-- return an instance of ItemActivationTest
return ExportSingleInstance("ItemActivationTest")
