use_safeglobals()

class "MainMenu" (Menu);

function MainMenu:__init()
	super()
	
	self:Initialize("Assets\\Screens\\MainMenu.xml")
end

function MainMenu:OnOpen()
	ShowBackdropMenu()
	
	self:OnOpenPlatform()
	
	-- Set the presence here.  When starting for the first time, or recovering from a
	-- reset, the Main Menu is the first place where we can be sure that the player
	-- is signed in.  So this is where we set the "initial" presence state.
	Presence:SetPresenceMode("NAVIGATING_MENUS")
	
	return Menu.OnOpen(self)
end

function MainMenu:OnRefresh()
	--if IsPlatformSTEAM() then
	--	self:activate_widget("butt_multiplayer")
	--	self:activate_widget("butt_achievements")
	--end
end

function MainMenu:OnTimer(time)
	return Menu.OnTimer(self, time)
end

function MainMenu:OnKey(key)
	if key == Keys.SK_ESCAPE then
		open_yesno_menu("[CONFIRM]", "[CONFIRM_QUIT]", function (option) 
			if not option then
				ForceExit()
			end
		end, "[YES]", "[NO]")
	elseif key == string.byte("S") or key == string.byte("s") then
		if not IsComputerBuildslaveAndBuildConfigRetail() then
			set_safearea_shown(not get_safearea_shown())
		end
	elseif key == string.byte("F") or key == string.byte("f") then
		if not IsComputerBuildslaveAndBuildConfigRetail() then
			set_fps_shown(not get_fps_shown())
		end
	elseif key == string.byte("B") or key == string.byte("b") then
		if not IsComputerBuildslaveAndBuildConfigRetail() then
			if LicenseMgr.SetLicensed then
				LicenseMgr:SetLicensed() -- TEMP
			end
		end
	elseif key == string.byte("A") or key == string.byte("a") then
		if not IsComputerBuildslaveAndBuildConfigRetail() and IsPlatformSTEAM() then
			show_achievements_ui()
		end
	elseif key == string.byte("C") or key == string.byte("c") then
		if not IsComputerBuildslaveAndBuildConfigRetail() and IsPlatformSTEAM() then
			open_yesno_menu("Clear Profile", "Do you want to clear all stats and achievements for this profile?", function (cancel)
				LOGF("STEAM: CLEARING PROFILE? %s", tostring(cancel))
				
				if not cancel then
					LOG(" result: %s", tostring(Steam.ClearAllStatsAndAchievements()))
				end
			end, "Yes", "NO!")
		end
	elseif key == string.byte("X") or key == string.byte("x") then
		if not IsComputerBuildslaveAndBuildConfigRetail() and IsPlatformSTEAM() then
			open_yesno_menu("Clear Profile", "Do you want to clear all stats (ONLY) for this profile?", function (cancel)
				LOGF("STEAM: CLEARING STATS? %s", tostring(cancel))
				
				if not cancel then
					LOG(" result: %s", tostring(Steam.ClearAllStats()))
				end
			end, "Yes", "NO!")
		end
	elseif key == string.byte("D") or key == string.byte("d") then
		if not IsComputerBuildslaveAndBuildConfigRetail() and IsPlatformSTEAM() then
			-- NICK: removed :)
		end
	elseif key == Keys.SK_F5 then
		if not IsComputerBuildslaveAndBuildConfigRetail() then
			-- NICK: removed :)
		end
	elseif key == Keys.SK_F7 then
		if not IsComputerBuildslaveAndBuildConfigRetail() then
			SCREENS.ItemActivationTest:Open()
		end
	elseif key == Keys.SK_F6 then
		if not IsComputerBuildslaveAndBuildConfigRetail() then
			LOGF("Adding Xbox Live Heroes To Profile")
		
			local heroesToCreate 	= {
				lvl10_a_xbox_live 	= "Hero.MPAssassinLow",
				lvl10_b_xbox_live 	= "Hero.MPBarbarianLow",
				lvl10_t_xbox_live 	= "Hero.MPInquisitorLow",
				lvl10_s_xbox_live 	= "Hero.MPWarMageLow",
				lvl25_a_xbox_live 	= "Hero.MPAssassinMedium",
				lvl25_b_xbox_live 	= "Hero.MPBarbarianMedium",
				lvl25_t_xbox_live 	= "Hero.MPInquisitorMedium",
				lvl25_s_xbox_live 	= "Hero.MPWarMageMedium",
				lvl50_a_xbox_live 	= "Hero.MPAssassinHigh",
				lvl50_b_xbox_live 	= "Hero.MPBarbarianHigh",
				lvl50_t_xbox_live 	= "Hero.MPInquisitorHigh",
				lvl50_s_xbox_live 	= "Hero.MPWarMageHigh",
				lvl50_templar 		= "Hero.MaxLevelTemplar",
				lvl50_barbarian 	= "Hero.MaxLevelBarbarian",
				lvl50_sorcerer 		= "Hero.MaxLevelSorcerer",
				lvl50_assassin 		= "Hero.MaxLevelAssassin",
			}        
			
			local HeroSaveManager = require("Hero.HeroSaveManager")
			
			HeroSaveManager:ResetSaving()
			HeroSaveManager:SetPlayer(1)
			HeroSaveManager:LoadHeroes(function () 
				-- Ensure that all heroes are loaded
				for index, save_data in pairs(HeroSaveManager:GetHeroList()) do
					HeroSaveManager:RetrieveHero(index)
				end

				-- Delete any heroes
				for name, def in pairs(heroesToCreate) do
					for index, save_data in pairs(HeroSaveManager:GetHeroList()) do
						if save_data.hero then
						else
						end
						
						if save_data.hero and save_data.hero:GetAttribute("name") == name then
							HeroSaveManager:DeleteHero(index, function (v) LOGF("DELETED %d (%s)", index, tostring(v)) end, function () LOGF("SHUTDOWN") end)
						end
					end
				end
				
				for name, def in pairs(heroesToCreate) do
					local hero = CreateStockHero(def)
					
					LOGF("  - %s <= %s", name, def)
					
					hero:InitialiseCampaign()
					hero:SetAttribute("name", name)
					
					HeroSaveManager:AddNewHero(hero)
					HeroSaveManager:SetActiveHero(hero)
					HeroSaveManager:SaveActiveHero(function () LOGF("SAVED: %s:%s", name,def) end, function ()LOGF("NOT SAVED: %s:%s", name,def) end)
				end
			end, function () end)
		end
	else
		return Menu.OnKey(self, key)
	end
	
	return Menu.MESSAGE_HANDLED
end

function MainMenu:QuitGame()
	open_yesno_menu("[CONFIRM]", "[CONFIRM_QUIT]", function (option) 
		if not option then
			ForceExit()
		end
	end, "[YES]", "[NO]")
end

function MainMenu:SinglePlayer()
	if _G.IsDemo() then
		CallScreenSequencer("MainMenu", "CreateHeroMenu")
	else
		CallScreenSequencer("MainMenu", function ()
			SCREENS.CustomLoadingMenu:SetupAndOpen(nil, function()
				local function Continue()
					if HeroManager:GetNumHeroes() > 0 then
						SCREENS.CustomLoadingMenu:Close()
						SCREENS.SelectHeroMenu:SetupAndOpen(function (selected)
							if selected then
								CallScreenSequencer("SelectHeroMenu", "SinglePlayerMenu")
							else
								CallScreenSequencer("SelectHeroMenu", "MainMenu")
							end
						end)
						SCREENS.SelectHeroMenu:StartAnimation("fadein")
					else
						CallScreenSequencer("CustomLoadingMenu", "CreateHeroMenu")
					end
				end
				local function Shutdown(heading, message) 
					_G.ResetToSplashWithError(heading, message)
				end
				HeroManager:LoadHeroes(Continue, Shutdown)
				MusicManager:SetState( "MENU" )
			end, "[LOADING]", 2000)
		end)
	end
end

function MainMenu:InstantAction()

	local params = SetupInstantActionBattle()
	local hero1 = params.heroes[1][1]
	local hero2 = params.heroes[2][1]
	
	local def = hero2.def
	
	if def and def.voice then
		SoundSystem.Load(string.format("vox_%s_bank", def.voice))
	end
	
	local function OnFinished()
		-- Restore presence
		Presence:SetPresenceMode("NAVIGATING_MENUS")
		
		DestroyHero(hero1)
		DestroyHero(hero2)
		
		if def and def.voice then
			SoundSystem.Unload(string.format("vox_%s_bank", def.voice))
		end
		
		SCREENS.MainMenu:Open()
	end

	local function OnFlee()
		-- Restore presence
		Presence:SetPresenceMode("NAVIGATING_MENUS")
		
		SCREENS.MainMenu:Open()
	end
	
	local function OnFight()
		Presence:SetPresenceMode("SINGLEPLAYER_BATTLE")
		Presence:SetPresenceContext("MONSTER", string.upper(hero2.def.name))
	end
	
	SCREENS.PreBattleMenu:SetupAndOpen({
		transitionFrom = "MainMenu", 
		playerHero = hero1, 
		monsterHero = hero2, 
		onFinished = OnFinished, 
		onFlee = OnFlee, 
		onFight = OnFight,
		onFinished = OnFinished,
		params = params
	})

end

function MainMenu:HelpAndOptions()
	CallScreenSequencer("MainMenu", function ()
		SCREENS.HelpAndOptionsMenu:SetupAndOpen(function ()
			CallScreenSequencer("HelpAndOptionsMenu", "MainMenu")
		end)
	end)
end

function MainMenu:MiniGames()
	SCREENS.MinigameSelectionMenu:Open()
	SCREENS.MinigameSelectionMenu:StartAnimation("fadein")
	SCREENS.MainMenu:Close()
end

function MainMenu:MultiPlayer()
	SCREENS.MPConnectionMenu:Open()
	SCREENS.MPConnectionMenu:StartAnimation("fadein")
	SCREENS.MainMenu:Close()
end

function MainMenu:Tournament()
	SCREENS.TournamentMenu:Open()
	SCREENS.MainMenu:Close()
end

function MainMenu:Steam()
	SCREENS.SteamMenu:Open()
	SCREENS.MainMenu:Close()
end


function MainMenu:OnButton(buttonId, clickX, clickY)
    if buttonId == self:get_widget_id("butt_quit") then
		self:QuitGame()
	elseif buttonId == self:get_widget_id("butt_singleplayer") then
		self:SinglePlayer()
	elseif buttonId == self:get_widget_id("butt_instantaction") then
		self:InstantAction()
	elseif buttonId == self:get_widget_id("butt_options") then
		self:HelpAndOptions()
	elseif buttonId == self:get_widget_id("butt_minigames") then
		self:MiniGames()
	elseif buttonId == self:get_widget_id("butt_multiplayer") then
		self:MultiPlayer()
	elseif buttonId == self:get_widget_id("butt_tournament") then
		self:Tournament()
	elseif buttonId == self:get_widget_id("butt_achievements") then
		self:Steam()
	else
		return Menu.OnButton(self, buttonId, clickX, clickY)
	end
	
	return Menu.MESSAGE_HANDLED
end

-- Any platform specific stuff in here
dofile("Assets/Scripts/Screens/MainMenuPlatform.lua")

-- return an instance of MainMenu
return ExportSingleInstance("MainMenu")
