local HoldTheLine = {}
local Spell = require("Spells/Spell")

--[[

You become immune to Stun, Daze, and Fear effects for your next turn. This spell's duration 
can be extended by matching Blue Mana on subsequent turns.

]]

HoldTheLine.id			= "HOLDTHELINE"
HoldTheLine.cost		= {
	green  = 6,
	yellow = 6,
}
HoldTheLine.icon		= "img_spell_hold_the_line"
HoldTheLine.short_name	= "HOLD"
HoldTheLine.sound	= "sp_holdtheline"
HoldTheLine.sound_ds = "snd_sp_buff"
HoldTheLine.sound_bank_ds = "BANK_SP_BUFF"
HoldTheLine.dietfxParticle	= "magicwall"
HoldTheLine.dietfxTexture	= "shield"
HoldTheLine.effects 	= {{"[HOLDTHELINE_EFFECT0_HEAD]", "[HOLDTHELINE_EFFECT0_BODY]"}}
HoldTheLine.title 		= Spell:GetTitleTag(HoldTheLine)
HoldTheLine.subtitles 	= {Spell:GetEffectTag(HoldTheLine, 0)}
HoldTheLine.cooldownForAI = 5
HoldTheLine.cooldown = 5
HoldTheLine.is_stat_logged  = true

function HoldTheLine:Apply(params)

	local duration = 8 + math.floor(params.source.state.yellow/6)
	
	return function ()
		Spell:Pause(Spell.SPELL_INTRO_PAUSE)
		Spell:ApplyStatusEffectTo(params.source, params, self, "TemporaryImmunity", duration*2, {"Stun", "LesserStun", "Fear"})

		params.source.state:RemoveAllStatusEffectsOfName("Stun")
		params.source.state:RemoveAllStatusEffectsOfName("LesserStun")
		params.source.state:RemoveAllStatusEffectsOfName("Fear")

		Spell:Pause(Spell.SPELL_MIN_DURATION)
		Spell:Pause(Spell.SPELL_OUTRO_PAUSE)
	end
end

function HoldTheLine:Notify(grid,notify)
	local heading, text, startTime = Spell:ShowStandardSpellHeader(self.title)
	
	Spell:AddParticleTrail("Paths.Yellow1", "LongPathYellow", 0, 0,1500)
	Spell:AddParticleTrail("Paths.Yellow2", "LongPathYellow", 0, 0,1500)
	Spell:AddParticleTrail("Paths.Yellow3", "LongPathYellow", 0, 0,1500)
	
	Spell:Pause(Spell.SPELL_INTRO_PAUSE)
	Spell:ShowStandardEffectSubtitle(self.subtitles[1], Spell.SPELL_MIN_DURATION)
	Spell:Pause(Spell.SPELL_OUTRO_PAUSE)
	Spell:RemoveStandardSpellHeader(heading, text, startTime)
end

return HoldTheLine
