local Howl = {}
local Spell = require("Spells/Spell")

Howl.id = "HOWL"
Howl.cost = {
	yellow = 8,
}
Howl.icon = "img_spell_howl"
Howl.short_name	= "HOWL"
Howl.sound	= "sp_howl"
Howl.sound_ds = "snd_sp_howl"
Howl.sound_bank_ds = "BANK_SP_HOWL"
Howl.dietfxParticle	= "magicexplosion"
Howl.dietfxTexture	= "Skull"
Howl.cooldownForAI = 5

Howl.effects = { 	{ "[HOWL_EFFECT0_HEAD]", "[HOWL_EFFECT0_BODY]" },	}
Howl.title = Spell:GetTitleTag(Howl)
Howl.subtitles = {
	Spell:GetEffectTag(Howl, 0),
}
Howl.cooldownForAI = 6
Howl.cooldown = 6

function Howl:Apply(params)
	return function()
		Spell:Pause(Spell.SPELL_INTRO_PAUSE)
		Spell:ApplyStatusEffectTo(params.target, params, self, "Fear", 11, 0, -25)
		Spell:Pause(Spell.SPELL_EFFECT_PAUSE)
		Spell:Pause(Spell.SPELL_OUTRO_PAUSE)
	end
end

function Howl:Notify(grid,notify)
	local heading, text, startTime = Spell:ShowStandardSpellHeader(self.title)
	
	
	
	Spell:ThrowParticle(notify,{"LongPathYellow","YellowExplosion"},{2,"str_def_value",0,0},2,0.5,700)
	for i=1,10 do		
		Spell:ThrowParticle(notify,{"LongPathYellow"},{2,"str_def_value",0,0},math.random(2,5),1.1,800,100*i)
	end
	
	
	--Shield Particle - Growing
	local particle = ParticleLibrary.CloneDescription(ParticleLibrary.FindDescription("Shield"))
	particle:SetColor(0.8,0.8,0.0,0.7)
	particle:SetTargetColor(0.8,0.8,0.0,0.7)
	particle:SetSize(0.6)
	particle:SetTargetSize(1.5)	
	particle:SetNumParticlesToRelease(10)
	particle:SetTotalParticles(10)
	particle:SetOffsetVariation(0)
	particle:SetVelocityVariation(0)
	particle:SetLifeCycle(200)
	
	
	local widgetsList = {
			{2,"str_def_value",-2,10};
			{2,"str_def_value",-2,0};
		};
	local path = Spell:WidgetPath(nil,notify,widgetsList,0,0)
	path:SetAttribute("Duration",200)
	Spell:AttachParticleMotionFragment(path, {particle}, nil,600)
	
	
	
	
	--Shield Particle - jittery
	particle = ParticleLibrary.CloneDescription(ParticleLibrary.FindDescription("Shield"))
	particle:SetColor(0.8,0.8,0.0,0.7)
	particle:SetTargetColor(0.8,0.8,0.0,0.7)
	particle:SetSize(1.5)
	particle:SetTargetSize(1.5)	
	particle:SetNumParticlesToRelease(10)
	particle:SetReleaseInterval(100)
	particle:SetOffsetVariation(0)
	particle:SetVelocityVariation(0)
	particle:SetLifeCycle(100)
	particle:SetLifetime(1000)
	
	local particle2 = ParticleLibrary.CloneDescription(ParticleLibrary.FindDescription("Shield"))
	particle2:SetColor(0.8,0.0,0.0,0.7)
	particle2:SetTargetColor(0.8,0.0,0.0,0.7)
	particle2:SetSize(1.55)
	particle2:SetTargetSize(1.55)	
	particle2:SetNumParticlesToRelease(2)
	particle2:SetReleaseInterval(200)
	particle2:SetOffsetVariation(0.05)
	particle2:SetVelocityVariation(0)
	particle2:SetLifeCycle(20)
	particle2:SetLifetime(1000)
	
	
	widgetsList = {}
	
	for i=1,20 do
		table.insert(widgetsList,{2,"str_def_value",math.random(-4,0),math.random(-2,2)})
	end
	path = Spell:WidgetPath(nil,notify,widgetsList,0,0)
	path:SetAttribute("Duration",1000)
	Spell:AttachParticleMotionFragment(path, {particle,particle2}, nil,800)
	
	
	--Shield Particle - Broken
	local particles = {}
	particles[1] = ParticleLibrary.CloneDescription(ParticleLibrary.FindDescription("ShieldBroken1"))
	particles[2] = ParticleLibrary.CloneDescription(ParticleLibrary.FindDescription("ShieldBroken2"))
	particles[3] = ParticleLibrary.CloneDescription(ParticleLibrary.FindDescription("SkullExp03"))
	particles[4] = ParticleLibrary.CloneDescription(ParticleLibrary.FindDescription("SkullExp04"))
	particles[5] = ParticleLibrary.CloneDescription(ParticleLibrary.FindDescription("SkullExp03"))
	particles[6] = ParticleLibrary.CloneDescription(ParticleLibrary.FindDescription("SkullExp04"))
	particles[1]:SetColor(0.8,0.8,0.0,0.7)
	particles[1]:SetTargetColor(0.8,0.8,0.0,0.7)
	particles[2]:SetColor(0.8,0.8,0.0,0.7)
	particles[2]:SetTargetColor(0.8,0.8,0.0,0.7)
	
	particles[5]:SetOffset(0,50,0)
	particles[5]:SetOffset(0,-50,0)
	
	
	widgetsList = {
			{2,"str_def_value",0,10};
			{2,"str_def_value",0,0};
		};
	path = Spell:WidgetPath(nil,notify,widgetsList,0,0)
	path:SetAttribute("Duration",800)
	Spell:AttachParticleMotionFragment(path, particles, nil,1800)
	
	
	
	Spell:ShowStandardEffectSubtitle(self.subtitles[1], Spell.SPELL_EFFECT_PAUSE)
	Spell:RemoveStandardSpellHeader(heading, text, startTime)
end

return Howl
