_G.Stats = {}

local SP_STATS = 
{
	ASSASSIN = 
	{
		COMPLETIONS_MALE		= {},
		COMPLETIONS_FEMALE		= {},
		VICTORIES_MALE			= {},
		VICTORIES_FEMALE		= {},
		BATTLE_COUNT			= {},
		TOTAL_DAMAGE			= {},
		BEST_DAMAGE				= {},
		TOTAL_ABSORBED			= {},
		BEST_PLAY_TIME			= {},	
		BEST_ENDURANCE_RESULT 	= {},
		ONLINE_BATTLES			= {},
		ONLINE_VICTORIES_MALE	= {},
		ONLINE_VICTORIES_FEMALE	= {},
	},
	
	BARBARIAN = 
	{
		COMPLETIONS_MALE		= {},
		COMPLETIONS_FEMALE		= {},
		VICTORIES_MALE			= {},
		VICTORIES_FEMALE		= {},
		BATTLE_COUNT			= {},
		TOTAL_DAMAGE			= {},
		BEST_DAMAGE				= {},
		BEST_ATTACK_RATING		= {},
		BEST_PLAY_TIME			= {},
		BEST_ENDURANCE_RESULT 	= {},
		ONLINE_BATTLES			= {},
		ONLINE_VICTORIES_MALE	= {},
		ONLINE_VICTORIES_FEMALE	= {},
	},
	
	INQUISITOR = 
	{
		COMPLETIONS_MALE		= {},
		COMPLETIONS_FEMALE		= {},
		VICTORIES_MALE			= {},
		VICTORIES_FEMALE		= {},
		BATTLE_COUNT			= {},
		TOTAL_DAMAGE			= {},
		BEST_DAMAGE				= {},
		BEST_BLOCK				= {},
		BEST_PLAY_TIME			= {},
		BEST_ENDURANCE_RESULT 	= {},
		ONLINE_BATTLES			= {},
		ONLINE_VICTORIES_MALE	= {},
		ONLINE_VICTORIES_FEMALE	= {},
	},
	
	WARMAGE = 
	{
		COMPLETIONS_MALE		= {},
		COMPLETIONS_FEMALE		= {},
		VICTORIES_MALE			= {},
		VICTORIES_FEMALE		= {},
		BATTLE_COUNT			= {},
		TOTAL_DAMAGE			= {},
		BEST_DAMAGE				= {},
		BEST_MANA_GAIN			= {},
		BEST_PLAY_TIME			= {},
		BEST_ENDURANCE_RESULT 	= {},
		ONLINE_BATTLES			= {},
		ONLINE_VICTORIES_MALE	= {},
		ONLINE_VICTORIES_FEMALE	= {},
	},
	
	OVERALL = 
	{
		GAMESWON					= {},
		GAMESLOST					= {},
		XP							= {},
		GOLD						= {},		
		CLASSES_COMPLETED			= {},
		
		ASSASSIN_KILLS				= {},
		BARBARIAN_KILLS				= {},
		INQUISITOR_KILLS			= {},
		WARMAGE_KILLS				= {},
		BATTLE_TIME					= {},
		
		TOURNAMENT_BATTLES			= {},
		TOURNAMENT_VICTORIES		= {},
		
		ENDURANCE_BATTLES			= {},
		ENDURANCE_VICTORIES			= {},
		
		HOARD_WINS					= {},
		SEARCH_AMBUSHES				= {},
		SEARCH_SECRETS				= {},
		SEARCH_TRAPS				= {},
		
		ROOMS_VISITED				= {},
		
		YETITURNS					= {},	
	},
	
	ENDURANCE 						= {
		AMBER						= {},
		CRYSTAL						= {},
		EMERALD						= {},
		FANG						= {},
		LEATHER						= {},
		METAL						= {},
		PEARL						= {},
		RUBY						= {},
		SAPPHIRE					= {},
		WOOD						= {},
	},
	
	CHALLENGE = 
	{
		-- Best victory times
		MIN_GREEN_DRAGON_TURNS		= {},
		MIN_TWO_HEADED_OGRE_TURNS	= {},
		MIN_GORGON_TURNS			= {},
		MIN_ARCH_LICH_TURNS			= {},
		MIN_SHADOWBRINGER_TURNS		= {},
		MIN_YETI_TURNS				= {}
	},
	
	TOURNAMENT 						= {
		GOBLINBOSS					= {},
		GOBLINWIZARD				= {},
		GOBLINWITCH					= {},
		GELATINOUSCUBE				= {},
		POLARBEAR					= {},
		RAKSHASA					= {},
		TROLL						= {},
		ORCBERZERKER				= {rename="BERZERKER"},
		ORCCHIEFTAN					= {rename="CHIEFTAIN"},
		ORCSHAMAN					= {rename="SHAMAN"},
		SKELETON					= {},
		CORRUPTEDORC				= {rename="DARKORC"},
		GHOUL						= {},
		WRAITH						= {},
		BASILISK					= {},
		CORRUPTEDORCCHIEFTAN		= {rename="DARKCHIEFTAIN"},
		LICH						= {},
		LEPRECHAUN					= {rename="IMP"},
		OGRE						= {},
		NECROMANCER					= {},
		MINOTAUR					= {},
		MUMMY						= {},
		OWLBEAR						= {},
		DARKELVENASSASSIN			= {},
		DARKELVENWARMAGE			= {},
		GREATERDEMON				= {rename="DAEMON"},
		HELLHOUND					= {},
	},
	
	SPELLS						= {
		SNEAKATTACK				= {},
		SWIFTSTRIKE				= {},
		CONFUSE					= {},
		STEALTH					= {},
		STONESTRIKE				= {},
		SEEKSHADOWS				= {},
		DISARM					= {},
		PRESSUREPOINTS			= {},
		BURNINGSTRIKE			= {},
		WEAKEN					= {},
		BLACKJACK				= {},
		FREEZINGSTRIKE			= {},
		BANDAGE					= {},
		BACKSTAB				= {},
		TAUNT					= {},
		DUALSHOT				= {},
		SHADOWSTRIKE			= {},
		PUMMEL					= {},
		TRIBALMARK				= {},
		SLAM					= {},
		SKULLCRUSHER			= {},
		BARBARICROAR			= {},
		WADEINBLOOD				= {},
		BACKSWING				= {},
		ENRAGE					= {},
		TRIBALWARD				= {},
		WARCRY					= {},
		BLOODIED				= {},
		STOMP					= {},
		BRUTALITY				= {},
		HEADHUNTER				= {},
		BLOODFURY				= {},
		DESTROYER				= {},
		BERZERKRAGE				= {},
		DEFENSIVEWALL			= {},
		SHIELDBASH				= {},
		FOCUS					= {},
		INTIMIDATE				= {},
		RUSH					= {},
		BRACE					= {},
		BARRIER					= {},
		COUNTER					= {},
		REINFORCE				= {},
		HOLDTHELINE				= {},
		FISTOFLIGHT				= {},
		DRAINPOWER				= {},
		HANDOFGOD				= {},
		OVERSHADOW				= {},
		DIVINEPOWER				= {},
		LASTSTAND				= {},
		HEAVENSWRATH			= {},
		MAGESTRIKE				= {},
		WILDMANA				= {},
		FUMBLEHEX				= {},
		DARKCHANNELS			= {},
		FLAMEBOLTS				= {},
		ICESHIELD				= {},
		FLAMEBLADE				= {},
		WEAKNESS				= {},
		HANDOFICE				= {},
		FINGEROFDEATH			= {},
		CHASM					= {},
		STONESKIN				= {},
		STRENGTH				= {},
		FIREBALL				= {},
		MIRRORSHIELD			= {},
		SOULDRAIN				= {},
		MANABLAST				= {},
	},
	
	ONLINE						= {
		TOTAL_DAMAGE			= {},
		BEST_DAMAGE				= {},
		BEST_DAMAGE_PER_TURN	= {},
		BEST_BLOCK				= {},
		
		SHORTEST_BATTLE			= {},
		LONGEST_BATTLE			= {},
		TOTAL_TURNS				= {},
		TOTAL_ENEMY_TURNS		= {},
		TOTAL_MOVES				= {},
		TOTAL_ENEMY_MOVES		= {},
		BONUS_MOVES				= {},
		BEST_BONUS_MOVES_STREAK	= {},
		
		CURRENT_STREAK			= {},
		BEST_STREAK				= {},
		
		ASSASSIN_V_ASSASSIN		= {},
		ASSASSIN_V_BARBARIAN 	= {},
		ASSASSIN_V_SORCERER		= {},
		ASSASSIN_V_TEMPLAR		= {},
		
		BARBARIAN_V_ASSASSIN	= {},
		BARBARIAN_V_BARBARIAN 	= {},
		BARBARIAN_V_SORCERER	= {},
		BARBARIAN_V_TEMPLAR		= {},
		
		SORCERER_V_ASSASSIN		= {},
		SORCERER_V_BARBARIAN 	= {},
		SORCERER_V_SORCERER		= {},
		SORCERER_V_TEMPLAR		= {},
		
		TEMPLAR_V_ASSASSIN		= {},
		TEMPLAR_V_BARBARIAN 	= {},
		TEMPLAR_V_SORCERER		= {},
		TEMPLAR_V_TEMPLAR		= {},
	},
}

function Stats.AdjustSPStat(board, name, amount)  -- amount can be nil
	LOGF("STATS: Updating '%s' in board '%s' with value '%s'", tostring(board), tostring(name), tostring(amount))
	
	assert(SP_STATS[board])
	assert(SP_STATS[board][name])
	
	table.insert(SP_STATS[board][name], amount or 1)
end

function Stats.PushSinglePlayerStats(cb)
	LOGF("STATS: Pushing stats OUTER")
	if not _G.IsDemo() then--No Stats submitted for Demo
		table.log(SP_STATS)
		Stats.PushSinglePlayerStatsPlatform(SP_STATS, cb)
	end
end

function Stats.GetSinglePlayerStats()
	return SP_STATS
end

function Stats.GetStat(category, name)
	return Stats.GetStatPlatform(SP_STATS, category, name)
end

-- The mechanism for recording and publishing status is different for every 
-- platform (XBLA uses Xbox Live, for example).
dofile("Assets/Scripts/StatsPlatform.lua")

return Stats
