local TemporaryImmunity = {}

TemporaryImmunity.id = "TEMPORARYIMMUNITY"
TemporaryImmunity.icon = "img_status_enhancement"
TemporaryImmunity.beneficial = true

function TemporaryImmunity:Apply(immunities)
	assert(immunities)
	assert(type(immunities) == "table")
	self.immunities = immunities
end

function TemporaryImmunity:OnAdd()
	for _, immunity in pairs(self.immunities) do
		self.source.state:SetImmunity(immunity, true)
	end
end

function TemporaryImmunity:OnRemove()
	for _, immunity in pairs(self.immunities) do
		self.source.state:SetImmunity(immunity, false)
	end
end

return TemporaryImmunity
